﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WG_BindToTwoDimArray
{
    class ArrayDataTable
    {
        private DataTable dt = new DataTable();

        public void CreateDataTable(Array array)
        {
            dt.Clear();
            if (array.Rank != 2)
                throw new ArgumentException("Use only two dimensional arrays");

            for (int i = 0; i < array.GetLength(1) ; i++)
            {
                DataColumn col = dt.Columns.Add(i.ToString(), typeof(double));
            }

            for (int i = 0; i < array.GetLength(0); i++)
            {
                dt.Rows.Add();
                for (int j = 0; j < array.GetLength(1); j++)
                {
                    dt.Rows[i].SetField(dt.Columns[j],(double)array.GetValue(i, j));
                }
            }
        }

        public void CreateDataTable(double[,] array, string[] colnames)
        {
            dt.Clear();
            if (array.Rank != 2)
                throw new ArgumentException("Use only two dimensional arrays");

            for (int i = 0; i < array.GetLength(1); i++)
            {
                DataColumn col = dt.Columns.Add(colnames[i], typeof(double));
            }

            for (int i = 0; i < array.GetLength(0); i++)
            {
                dt.Rows.Add();
                for (int j = 0; j < array.GetLength(1); j++)
                {
                    dt.Rows[i].SetField(dt.Columns[j], (double)array.GetValue(i, j));
                }
            }
        }

        public DataTable ArrayTable
        {
            get { return dt; }
        }

        
    }
}
